openfoam/wmake/wclean
Mark Olesen 9707e5c100 ENH: "wmake all" makes 'libso' instead of 'exe' where appropriate
- adds more DWIM (do what I mean) intelligence to wmake

ENH: use ~/.OpenFOAM/.wmake instead of ~/.wmakeScheduler for the lock dir

- keeps more of the OpenFOAM bits together
2010-04-19 10:54:23 +02:00

152 lines
4.1 KiB
Bash
Executable File

#!/bin/sh
#------------------------------------------------------------------------------
# ========= |
# \\ / F ield | OpenFOAM: The Open Source CFD Toolbox
# \\ / O peration |
# \\ / A nd | Copyright (C) 1991-2010 OpenCFD Ltd.
# \\/ M anipulation |
#-------------------------------------------------------------------------------
# License
# This file is part of OpenFOAM.
#
# OpenFOAM is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with OpenFOAM. If not, see <http://www.gnu.org/licenses/>.
#
# Script
# wclean
#
# Description
# Clean up the wmake control directory Make/\$WM_OPTIONS and remove the
# lnInclude directories generated for libraries.
#
#------------------------------------------------------------------------------
Script=${0##*/}
usage() {
while [ "$#" -ge 1 ]; do echo "$1"; shift; done
cat<<USAGE
Usage: $Script [OPTION] [dir]
$Script [OPTION] target [dir [MakeDir]]
options:
-help print the usage
Clean up the wmake control directory Make/\$WM_OPTIONS and remove the
lnInclude directories generated for libraries.
The targets correspond to a subset of the 'wmake' special targets:
all all subdirectories, uses any Allwclean or Allclean
files if they exist
exe | lib | libo | libso
clean Make, any *.dep files and lnInclude directories
USAGE
exit 1
}
# provide immediate help
if [ "$1" = "-h" -o "$1" = "-help" ]
then
usage
fi
#------------------------------------------------------------------------------
# check arguments and change to the directory in which to run wmake
#------------------------------------------------------------------------------
unset dir makeOption
MakeDir=Make
if [ $# -ge 1 ]
then
if [ -d "$1" ]
then
dir=$1
else
makeOption=$1
fi
# specified directory name:
[ $# -ge 2 ] && dir=$2
# specified alternative name for the Make sub-directory:
[ $# -ge 3 ] && MakeDir=$3
if [ "$dir" ]
then
cd $dir 2>/dev/null || {
echo "$Script error: could not change to directory '$dir'" 1>&2
exit 1
}
fi
# provide some feedback
echo "$Script ${dir:-./}"
fi
#------------------------------------------------------------------------------
# Recurse the directories tree
#------------------------------------------------------------------------------
if [ "$makeOption" = all ]
then
if [ -e Allwclean ] # consistent with Allwmake
then
./Allwclean
exit $?
elif [ -e Allclean ] # often used for tutorial cases
then
./Allclean
exit $?
elif [ ! -d $MakeDir ]
then
for dir in `find . \( -type d -a -name Make \) -printf "%h "`
do
$0 $dir
done
exit 0
fi
fi
# makeOption is not needed beyond this point
unset makeOption
#------------------------------------------------------------------------------
# Require the existence of the 'Make' directory
#------------------------------------------------------------------------------
[ -d $MakeDir ] || {
echo "$Script error: '$MakeDir' directory does not exist" 1>&2
exit 1
}
# -----------------------------------------------------------------------------
rm -rf $MakeDir/$WM_OPTIONS $MakeDir/classes 2>/dev/null
find . -name "*.dep" -exec rm {} \;
# always safe to remove lnInclude
rm -rf lnInclude 2>/dev/null
rm -rf ii_files Templates.DB 2>/dev/null
rm -f so_locations 2>/dev/null
#------------------------------------------------------------------------------